#include<unistd.h>
#include<sys/types.h>
#include<stdio.h>
#include<stdlib.h>
#include<limits.h>

#include "../common/global.hpp"
#include "../common/read_data.hpp"

using namespace std;

typedef long long __int64;

//read in phenotype and SNP data
//the first row is phenotype
//the remaining ones are SNPs
//1's are the minority allels
//generate X and directX
//sort function can be called in the procedure or not
void getin_data(qtPhenotype& Y, vector<biSNP>& X, vector<long>& X_pos)
{

	//generate Y
	Y.clear();

    read_qt_phenotypes(pheno_infile, Y);
    /*
	float tempy;

	for (int j=0;j<TOTAL_NUMBER_OF_INDIVIDUALS;j++)
	{
	    datain_pheno>>tempy;
	    Y.push_back(tempy);
	}

	bitset<MAX_NUMBER_OF_INDIVIDUALS> mask;
	mask.reset();
	for (int j=0;j<TOTAL_NUMBER_OF_INDIVIDUALS;j++){
	    mask.set(j);	    
	}
	*/
	    
	//generate X

    if (read_bi_genotypes(geno_infile,X)<0){
        exit(1);        
    }    

    biSNP tempSNP(MAX_NUM_OF_INDIVIDUALS);        

    

    //generate directX
	directX = new biSNP[NUMBER_OF_SNPs];

	vector<biSNP>::const_iterator iter;

	iter=X.begin();
    
	for (int i=0; i<NUMBER_OF_SNPs; i++) 
	{
        directX[i].resize(MAX_NUM_OF_INDIVIDUALS);
        
		directX[i].reset(); 
		
		directX[i] |= (*iter);

		iter++;
	}
	

	//sort X using directX

	X.clear();

	for (int ct=0;ct<(TOTAL_NUMBER_OF_INDIVIDUALS-(TOTAL_NUMBER_OF_INDIVIDUALS/2))+1; ct++)
	{
		for(int i=0;i<NUMBER_OF_SNPs;i++)
		{
			if (directX[i].count()==ct) 
			{
				tempSNP.reset();
				tempSNP |= directX[i];
				X.push_back(tempSNP);
			}
		}
	}

	//X.reverse();

    vector <biSNP> _X;
    
	for (int i=X.size()-1; i>=0; i--)
        _X.push_back(X[i]);
    
    X.clear();
    for (int i=0; i<_X.size(); i++)
        X.push_back(_X[i]);    

	//resort directX
    
	//iter=X.begin();        
    
    int j=0;    
	for (int i=0; i<NUMBER_OF_SNPs; i++) 
	{
		directX[i].reset(); 
		
		directX[i] |= X[j];

		//iter++;
        ++j;        
	}

    
    //cout <<"X=" <<endl;
    //for (vector<biSNP>::iterator iter=X.begin() ; iter!=X.end() ; ++iter)
    //    cout <<(*iter) <<endl;

    //cout <<"directX" <<endl;    
    //for (int i=0; i<NUMBER_OF_SNPs; i++)
    //    cout <<directX[i] <<endl;
    
    //exit(1);
    

	//cout <<INPUTFILE_3;	
	if (INPUTFILE_3.length()<=0) {
//	    long base_pos=rand()%1000;
//	    long delta_pos=0;
	    min_pos=0;
	    
//	    ofstream out;
//	    out.open("pos.txt");	    
	    for (long j=0; j<NUMBER_OF_SNPs ; ++j){
		X_pos.push_back(j);
//		base_pos+=delta_pos;		
//		X_pos.push_back(base_pos);
//		delta_pos=rand()%10000;
//		out <<base_pos <<" ";
	    }
	    max_pos=NUMBER_OF_SNPs;
	}
	
	else{
	    datain_geno_pos.open(INPUTFILE_3.c_str());
	    if (datain_geno_pos.fail()){
		cerr <<"IN3:Cannot open "+INPUTFILE_3+" to read!" <<endl;
		exit(1);                
	    };
	    for (long j=0; j<NUMBER_OF_SNPs ; ++j){
		long tmp;
		datain_geno_pos >>tmp;		
		X_pos.push_back(tmp);
	    }
	    min_pos=X_pos[0];
	    max_pos=X_pos[X_pos.size()-1];	    
	}
    
	/*
	cout <<min_pos <<" ";
	cout <<max_pos <<" ";
	cout <<endl;
	*/
}


//output a list of SNPs (type X)
void output_SNPlist(const vector<biSNP>& X)
{
	vector<biSNP>::const_iterator iter;

	for (iter=X.begin();iter!=X.end();iter++)
	{
		cout<<(*iter)<<endl;

	}

	cout<<endl;
}

//output a list of SNPs (type DirextX)
void output_SNPlist(const biSNP directX[])
{
	for (int i=0;i<NUMBER_OF_SNPs;i++)
	{
		cout<<directX[i]<<endl;
	}

	cout<<endl;


}


void output_intlist(const list<int>& ilist)
{
	list<int>::const_iterator iter;

	for (iter=ilist.begin();iter!=ilist.end();iter++)
	{
		cout<<*iter<<" ";
	}

	cout<<endl<<endl;

}


void output_floatlist(const list<float>& flist)
{
	list<float>::const_iterator iter;

	for (iter=flist.begin();iter!=flist.end();iter++)
	{
		cout<<*iter<<" ";
	}

	cout<<endl<<endl;

}

void dataoutput_floatlist(const list<float>& flist)
{
	list<float>::const_iterator iter;

	for (iter=flist.begin();iter!=flist.end();iter++)
	{
		cout<<*iter<<" ";
	}

	cout<<endl<<endl;

}


void dataoutput_pheno(const qtPhenotype& flist)
{
    qtPhenotype::const_iterator iter;

	for (iter=flist.begin();iter!=flist.end();iter++)
	{
		cout<<*iter<<" ";
	}

	cout<<endl<<endl;

}


//output ctable_2
void output_ctable_2(const list<float> ctable_2[2])
{
	for (int i=0;i<2;i++)
	{
		output_floatlist(ctable_2[i]);

	}

	cout<<endl;
}


//output ctable_4
void output_ctable_4(const list<float> ctable_4[4])
{
	for (int i=0;i<4;i++)
	{
		output_floatlist(ctable_4[i]);

	}

	cout<<endl;
}

void dataoutput_ctable_4(const list<float> ctable_4[4])
{
    for (int i=0;i<4;i++)
    {
        switch (i) {
        case 0:
            cout <<"#Group[0,0]:";
            break;
        case 1:
            cout <<"#Group[0,1]:";
            break;            
        case 2:
            cout <<"#Group[1,0]:";
            break;            
        case 3:
            cout <<"#Group[1,1]:";
        }
        
	dataoutput_floatlist(ctable_4[i]);        
    }
}

void output_Ylist_permutation(const list<float> Ylist[])
{
	for (int p=0;p<PERMUTATION;p++)
	{
		output_floatlist(Ylist[p]);
	}
}




void output64int()
{
	__int64 i;
//	i=1211212121212122112;
	i= 0X7FFFFFFFFFFFLL;
	char buf[20];
    sprintf(buf,"%lld", i );

	dataout<<buf;

}

/*



//output a 2 by 4 contingency table
//actually 3 by 5 including sums
void output_2_4_table(const float ctable[3][5])
{
	for (int i=0;i<3;i++)
	{
		for (int j=0;j<5;j++)
		{
			dataout<<ctable[i][j]<<" ";
		}

		dataout<<endl;
	}
}

void output_r1list(const R1list& r1list)
{
	dataout<<"r1: "<<r1list.r1<<endl;

	list<R2list>::const_iterator iter;

	for (iter=r1list.r2list.begin();iter!=r1list.r2list.end();iter++)
	{
		dataout<<"r2: "<<(*iter).r2<<endl;
		dataout<<"jlist size: "<<(*iter).jlist.size()<<endl;;
		dataout<<"j: ";
		output_intlist((*iter).jlist);
	}
}

void output_listofr1list(const list<R1list>& listofr1list)
{

	list<R1list>::const_iterator iter;

	for (iter=listofr1list.begin();iter!=listofr1list.end();iter++)
	{
		output_r1list(*iter);
		dataout<<"----------------"<<endl;
	}

	dataout<<"*********************************************"<<endl;
}

*/
void fill_ctable_4(const qtPhenotype& Y, const biSNP& X1, const biSNP& X2, list<float> ctable_4[4]);

//output the F(XiXj,Y)>F_alpha list to file
void dataoutput_significant(const list<TwoLocus>& sign_list, const qtPhenotype& Y, const vector<long>& X_pos)
{
    list<TwoLocus>::const_iterator iter;
    list<float> ctable_4[4];
    
    for (iter=sign_list.begin();iter!=sign_list.end();iter++)
    {	cout<<"#F Value: " <<endl
               <<(*iter).F_score<<endl;
	
        cout<<"#Genotype Id: "<<endl
               <<X_pos[(*iter).Xi_id] <<endl
               <<(*iter).Xi_genotype <<endl;
        
	cout<<"#Genotype Id: "<<endl
               <<X_pos[(*iter).Xj_id] <<endl
               <<(*iter).Xj_genotype <<endl;
        
	//fill_ctable_4(Y, (*iter).Xi_genotype, (*iter).Xj_genotype, ctable_4);
	//dataout<<"#Group of Genotype: "<<endl;        
	//fill_ctable_4(Y, (*iter).Xi_genotype, (*iter).Xj_genotype, ctable_4);        
	//dataoutput_ctable_4(ctable_4);


	cout<<"#------------------------------#"<<endl <<endl;

    } 
}

void dataoutput_topklist(const list<TwoLocus>& topk_list, const qtPhenotype* Ylist, const vector<long>& X_pos)
{

    list<float> ctable_4[4];
	
    list<TwoLocus>::const_iterator iter;

    cout <<"#=========== TopK Critical Value details ============#" <<endl;
    
    for (iter=topk_list.begin();iter!=topk_list.end();iter++)
    {
        int p=(*iter).phenotype_id;
	cout<<"#F Value: " <<(*iter).F_score<<endl;
		
        cout<<"#Phenotype Permutation: " <<endl	
               <<"#[" <<p <<"]: ";	
        dataoutput_pheno(Ylist[p]);

        cout<<"#Genotype Id: "<<endl
	       <<"#" <<X_pos[(*iter).Xi_id] <<endl
               <<"#" <<(*iter).Xi_genotype <<endl;
        
	cout<<"#Genotype Id: "<<endl
               <<"#" <<X_pos[(*iter).Xj_id] <<endl
               <<"#" <<(*iter).Xj_genotype <<endl;
        
	//fill_ctable_4(Y, (*iter).Xi_genotype, (*iter).Xj_genotype, ctable_4);
	cout<<"#Group of Genotype: "<<endl;        
	fill_ctable_4(Ylist[p], (*iter).Xi_genotype, (*iter).Xj_genotype, ctable_4);        
	dataoutput_ctable_4(ctable_4);
	
	cout<<"#-------------------------------#"<<endl <<endl;

    }
}


void dataoutput_permutations(const qtPhenotype *Ylist)
{
    cout <<"#============== Permutations details ==================#" <<endl;	
    for (int p=0;p<PERMUTATION;p++)
    {
	cout <<"#[" <<p+1 <<"]: ";
	dataoutput_pheno(Ylist[p]);		
	//dataout<<endl;
    }
    cout <<endl <<endl;    
}

void dataoutput_args()
{
    dataout <<"#================= Runtime Arguments ==================#" <<endl;
    dataout<<"#Num of Individuals(Phenotypes)"<<endl
	   <<"#" <<TOTAL_NUMBER_OF_INDIVIDUALS <<endl;
	
    dataout<<"#Num of Genotypes"<<endl
	   <<"#" <<NUMBER_OF_SNPs <<endl;

    dataout<<"#Minimum Position of Genotypes"<<endl
	   <<min_pos <<endl;
    
    dataout<<"#Maximum Position of Genotypes"<<endl
	   <<max_pos <<endl;
	
    dataout<<"#Num of Permutations"<<endl
	   <<"#" <<PERMUTATION <<endl;
	
    dataout<<"#TopK"<<endl
	   <<"#" <<TOPK <<endl <<endl <<endl;
}
