using namespace std;



//fill all emlements in the contingency table of X1
//ctable_2[0]: X1=0; ctable_2[1]: X1=1
// no need to clear before or after
//Y is phenotype and X1 is SNP
//the phenotype observations are sorted from small to large: (0.1, 0.2, ...)
void fill_ctable_2(const qtPhenotype& Y, const biSNP& X1, list<float> ctable_2[2])
{
	ctable_2[0].clear();
	ctable_2[1].clear();

	qtPhenotype::const_iterator iter;

	int i=TOTAL_NUMBER_OF_INDIVIDUALS-1;

	for (iter=Y.begin();iter!=Y.end();++iter)
	{

		if (X1.test(i)==0) 
		{
			ctable_2[0].push_back(*iter);
		}
		if (X1.test(i)==1) 
		{
			ctable_2[1].push_back(*iter);
		}

		i--;
	}

	//sort the phenotype observations
	ctable_2[0].sort();
	ctable_2[1].sort();
}



//fill all emlements in the contingency table of X1 and X2
//ctable_4[0]: X1X2=00; ctable_4[1]: X1X2=01; ctable_4[2]: X1X2=10; ctable_4[3]: X1X2=11
// no need to clear before or after
//Y is phenotype and X1 X2 are SNPs
//the phenotype observations are NOT sorted (no need to sort)
void fill_ctable_4(const qtPhenotype& Y, const biSNP& X1, const biSNP& X2, list<float> ctable_4[4])
{
	ctable_4[0].clear();
	ctable_4[1].clear();
	ctable_4[2].clear();
	ctable_4[3].clear();

    qtPhenotype::const_iterator iter;

	int i=TOTAL_NUMBER_OF_INDIVIDUALS-1;
/*
	for (iter=Y.begin();iter!=Y.end();iter++)
	{

		if (X1.test(i)==0) 
		{
			if (X2.test(i)==0) 
			{
				ctable_4[0].push_back(*iter);
			}
			if (X2.test(i)==1) 
			{
				ctable_4[1].push_back(*iter);
			}
		}
		if (X1.test(i)==1) 
		{
			if (X2.test(i)==0) 
			{
				ctable_4[2].push_back(*iter);
			}
			if (X2.test(i)==1) 
			{
				ctable_4[3].push_back(*iter);
			}
		}

		i--;
	}
*/
	for (iter=Y.begin();iter!=Y.end();++iter)
	{
	    if (X1.test(i)==0) 
	    {
		if (X2.test(i)==0)		
		    ctable_4[0].push_back(*iter);
		else
		    ctable_4[1].push_back(*iter);
	    }
	    else
	    {
		if (X2.test(i)==0)		
		    ctable_4[2].push_back(*iter);
		else
		    ctable_4[3].push_back(*iter);
	    }
	    i--;
	}
}
