using namespace std;


//overload operator < for sorting SNPs in desending order of supports
bool operator<(const biSNP& a, const biSNP& b) 
{
    return (TOTAL_NUMBER_OF_INDIVIDUALS - a.count()) < (TOTAL_NUMBER_OF_INDIVIDUALS - b.count());
}


//overload operator < for sorting topk_list in decending order of chi_score
bool operator<(const TwoLocus& a, const TwoLocus& b) 
{
    return (0 - a.F_score) < (0 - b.F_score);
}


//update topk_list
//keep it within length k
//ordered in decending order of chi_score
/*
void update_topk_list(list<TwoLocus>& topk_list, const TwoLocus& element)
{

	if (topk_list.size()<TOPK) 
	{
		topk_list.push_back(element);
	}

	else 
		if (element.F_score > topk_list.back().F_score) 
		{
			if (topk_list.size()==TOPK) 
			{
				topk_list.pop_back();
			}

			topk_list.push_back(element);

		}

		topk_list.sort();
}
*/

//update topk_list WITH PHENOTYOPE ID
//keep it within length k
//ordered in decending order of chi_score
void update_topk_list_pid(list<TwoLocus>& topk_list, const TwoLocus& element)
{
    if (topk_list.size()>=TOPK && element.F_score<=topk_list.back().F_score)
	return;    
	
    list<TwoLocus>::iterator iter;
    
    list<TwoLocus>::iterator iter_pheno=topk_list.end();
    
    list<TwoLocus>::iterator iter_insert=topk_list.end();

    //cout <<"lala" <<endl;
    
    for (iter=topk_list.begin();iter!=topk_list.end();++iter)
    {
	if ((*iter).phenotype_id == element.phenotype_id) 
	{
	    iter_pheno=iter;
	}
	if ( (iter_insert==topk_list.end()) && ((*iter).F_score<=element.F_score) )
	{
	    iter_insert=iter;		
	}	    
    }

    //cout <<"lala2" <<endl;
    //not full yet
    if (topk_list.size()<TOPK) 
    {	
	if (iter_pheno!=topk_list.end()) {
	    if ((*iter_pheno).F_score<element.F_score){		
		topk_list.insert(iter_insert,element);
		topk_list.erase(iter_pheno);
	    }
	    else{
		//dummy: do nothing.
	    }	    
	}
	else {
	    topk_list.insert(iter_insert,element);
	}	
    }
    //the list is full already
    else 
    {
	if (iter_pheno!=topk_list.end()) {
	    if ((*iter_pheno).F_score<element.F_score){		
		topk_list.insert(iter_insert,element);
		topk_list.erase(iter_pheno);
	    }
	    else{
		//dummy: do nothing.
	    }	    
	}
	else {	    
	    topk_list.insert(iter_insert,element);
	    topk_list.pop_back();
	}
    }
    /*
    cout <<"lala3" <<endl;
    for (iter=topk_list.begin();iter!=topk_list.end();++iter)
    {
	cout <<(*iter).F_score <<" ";
	
    }
    cout <<endl;
    */
}

/*
void update_topk_list_pid(list<TwoLocus>& topk_list, const TwoLocus& element)
{

	list<TwoLocus>::iterator iter;

	//not full yet
	if (topk_list.size()<TOPK) 
	{
//		topk_list.push_back(element);


		for (iter=topk_list.begin();iter!=topk_list.end();++iter)
		{
			if ((*iter).phenotype_id == element.phenotype_id) 
			{
				break;
			}
		}

		//phenotype not exist in the list
		if (iter == topk_list.end()) 
		{
			topk_list.push_back(element);
		}

		//phenotype exists in the list already
		else
		{
			if (element.F_score > (*iter).F_score)
			{
				topk_list.erase(iter);

				topk_list.push_back(element);

			}


		}

	}

	//the list is full already
	else 
	{

//		if (element.F_score > topk_list.back().F_score) 
//		{
//			if (topk_list.size()==TOPK) 
//			{
//				topk_list.pop_back();
//			}
//
//			topk_list.push_back(element);
//
//		}


		if (element.F_score > topk_list.back().F_score) 
		{

			for (iter=topk_list.begin();iter!=topk_list.end();++iter)
			{
				if ((*iter).phenotype_id == element.phenotype_id) 
				{
					break;
				}
			}

			//phenotype not exist in the list
			if (iter == topk_list.end()) 
			{
				topk_list.pop_back();

				topk_list.push_back(element);
			}

			//phenotype exists in the list already
			else
			{

				if (element.F_score > (*iter).F_score)
				{
					topk_list.erase(iter);

					topk_list.push_back(element);

				}


			}



		}

	
	}


	//always sort
	topk_list.sort();
}
*/


