using namespace std;

float max ( const float & a, const float & b ) 
{
  return (b<a)?a:b;
}

float min ( const float & a, const float & b ) 
{
  return (b>a)?a:b;
}



void get_R1_R2(const biSNP& Xi, const biSNP& Xj, float& R1, float& R2)
{

	R1=R2=0;

	float sup1_=Xi.count(); 
	float sup_1=Xj.count();


	Intermedia temp11(MAX_NUM_OF_INDIVIDUALS);
	temp11 |= Xi; temp11 &= Xj;

	float sup11 = temp11.count();

//	float sup10 = sup1_ - sup11;
	
	float sup01 = sup_1 - sup11;

//	float sup00 = TOTAL_NUMBER_OF_INDIVIDUALS - sup11 - sup10 - sup01;

	R1 = sup01;

	R2 = sup11;
}



//update r1list
void update_r1list(R1list& r1list, const float& r2, const int& jid)
{
	list<R2list>::iterator iter;

	R2list tempr2list;

	iter=r1list.r2list.begin();

	//find the right position
	while ((iter!=r1list.r2list.end()) && (r2 < (*iter).r2))  
	{
		++iter;
	}

	//if r2 is less than all the r2 value in the r2list, or the r2list is empty, then directly push back
	if (iter==r1list.r2list.end()) 
	{
		tempr2list.r2=r2;
		tempr2list.jlist.push_back(jid);

		r1list.r2list.push_back(tempr2list);
	}
	
	else
	{
		//if r2 already exists in the r2list, then push back j in the corresponding r2list
		if (r2==(*iter).r2) 
		{
			(*iter).jlist.push_back(jid);

		}

		//else insert a new r2list using r2 and jid
		else 
		{
			tempr2list.r2=r2;
			tempr2list.jlist.push_back(jid);

			r1list.r2list.insert(iter, tempr2list);

		}

	}

}



//for a SNP Xi, update its list of r1lists
void update_list_of_r1list(list<R1list>& listofr1list, const float& r1, const float& r2, const int&jid)
{
	list<R1list>::iterator iter;

	R1list tempr1list;

	iter=listofr1list.begin();

	//find the right position
	while ((iter!=listofr1list.end()) && (r1 < (*iter).r1) )
	{
		++iter;
	}

	//if r1 is less than all the r1 value in the listofr1list, or the listofr1list is empty, then directly push back
	if (iter==listofr1list.end()) 
	{
		tempr1list.r1=r1;
		update_r1list(tempr1list, r2, jid);

		listofr1list.push_back(tempr1list);
	}

	else
	{
		//if r1 already exists in the listofr1list, then update the corresponding r1list
		if (r1==(*iter).r1)
		{
			update_r1list(*iter, r2, jid);
		}

		//else insert a new r1list using r1, r2 and jid
		else 
		{
			tempr1list.r1=r1;
			update_r1list(tempr1list, r2, jid);

			listofr1list.insert(iter, tempr1list);
			
		}

	}


}

//get the sum of the first m elements in the flist
float get_sum_of_first_m_elements(list<float>& flist, const float& m)
{
	if (flist.size()<m) 
	{
		cout<<"cell size wrong 1! "<<endl;
		return 0;
	}

	float sum=0;
	
	list<float>::iterator iter;
	iter=flist.begin();

	for (int i=0;i<m;i++)
	{
		sum = sum + *iter;

		++iter;
	}

	return sum;
}


//get the sum of the last m elements in the flist
float get_sum_of_last_m_elements(list<float>& flist, const float& m)
{
	if (flist.size()<m) 
	{
		cout<<"cell size wrong 2! "<<endl;
		return 0;
	}

	float sum=0;
	
	//reverse
	flist.reverse();
	
	list<float>::iterator iter;
	iter=flist.begin();

	for (int i=0;i<m;i++)
	{
		sum = sum + *iter;

		++iter;
	}

	//reverse back to original
	flist.reverse();

	return sum;
}


//get one R
//flist_A contains the phenotype observations in cell A (or cell B)
//m is the number of 1's in X_j, when X_i =0 (or 1)
float get_one_R(list<float>& flist_A, const float& m)
{
	float m_A = flist_A.size();

//	cout<<"m_A: "<<m_A<<endl;

	float T_A = get_T(flist_A);

//	cout<<"T_A: "<<T_A<<endl;

	if (m_A == 0) 
	{
//		cout<<"the CELL A or B is empty !"<<endl;
		return 0;
	}

	if ( ((m_A - m)==0) || (m == 0) )
	{
		return 0;
	}

	float alpha = get_sum_of_first_m_elements(flist_A, m);

//	cout<<"alpha: "<<alpha<<endl;

	float beta = get_sum_of_last_m_elements(flist_A, m);

//	cout<<"beta: "<<beta<<endl;

	float temp1 = (m_A * alpha) - (m * T_A);

//	cout<<"temp1: "<<temp1<<endl;

	float R1 = temp1 * temp1;

	float temp2 = (m_A * beta) - (m * T_A);

//	cout<<"temp2: "<<temp2<<endl;


	float R2 = temp2 * temp2;

	float R = max(R1, R2);

	return R/(m * (m_A - m) * m_A);

}

//get the upper bound of Delta_A (or Delta_B)
//flist_A contains the phenotype observations in cell A (or cell B)
//m is the number of 1's in X_j, when X_i =0 (or 1)
float get_upperbound(list<float>& flist_A, const float& m)
{
	float upperbound=0;

	upperbound = get_one_R(flist_A, m);
//	upperbound = min( get_one_R(flist_A, m), get_one_R(flist_A, flist_A.size() - m) );

	return upperbound;
}



//get the SNP ids (Xj's) from a list of R1list of the SNP Xi
//candidate list is cleared within the procedure
//flist_A contains the phenotype observations in cell A
//flist_B contains the phenotype observations in cell B
void access_list_of_r1list(list<float>& flist_A, list<float>& flist_B, const list<R1list>& listofr1list, const float SSB_XiY, const float SS_Total, const float theta, list<int>& candidates)
{
	candidates.clear();

	float threshold = SS_Total/( ( (TOTAL_NUMBER_OF_INDIVIDUALS-4)/(3*theta) ) + 1);

	float threshold1 = SS_Total/( ( (TOTAL_NUMBER_OF_INDIVIDUALS-3)/(2*theta) ) + 1);

//	cout<<threshold<<endl;

	list<R1list>::const_iterator iter1;
	list<R2list>::const_iterator iter2;

	list<int>::const_iterator iter3;

	int j=0;

	float uA=0, uB=0;



	for (iter1=listofr1list.begin();iter1!=listofr1list.end();++iter1)
	{
		for (iter2=(*iter1).r2list.begin();iter2!=(*iter1).r2list.end();++iter2)
		{

			uA = get_upperbound(flist_A, (*iter1).r1);
			uB = get_upperbound(flist_B, (*iter2).r2);

			if ((uA!=0)&&(uB!=0)) 
			{
				if (SSB_XiY + uA + uB >= threshold) 
				{
					for (iter3=(*iter2).jlist.begin();iter3!=(*iter2).jlist.end();iter3++)
					{

						j=*iter3;
						candidates.push_back(j);

					}

				}
			}

			else
			{

				if (SSB_XiY + uA + uB >= threshold1) 
				{
					for (iter3=(*iter2).jlist.begin();iter3!=(*iter2).jlist.end();++iter3)
					{

						j=*iter3;
						candidates.push_back(j);

					}

				}



			}




		}
	}

}


//permute phenotype according to Y
//and fill them in Ylist[PERMUTE]
void permute_phenotype(const qtPhenotype& Y, qtPhenotype Ylist[])
{
	float tempY[TOTAL_NUMBER_OF_INDIVIDUALS];

    qtPhenotype::const_iterator iter0;

	int i=0;

	for (iter0=Y.begin();iter0!=Y.end();++iter0)
	{
		tempY[i] = *iter0;

		i++;
	}

	int r;
	list<int> rnumbers;

	list<int>::const_iterator iter;

	
	srand(1);//((unsigned)time( NULL ) );


	for (int p=0;p<PERMUTATION;p++)
	{
//		cout<<"-------"<<endl;
//		getchar();

		rnumbers.clear();

		while (rnumbers.size()!=TOTAL_NUMBER_OF_INDIVIDUALS) 
		{
			r = rand();
			r= r - (TOTAL_NUMBER_OF_INDIVIDUALS*(r/TOTAL_NUMBER_OF_INDIVIDUALS));

//			cout<<r<<endl;

			if (find(rnumbers.begin(), rnumbers.end(), r) == rnumbers.end()) 
			{
				rnumbers.push_back(r);
			}

		}

//		cout<<endl;
		//overwrite Y
		Ylist[p].clear();

		for(iter=rnumbers.begin();iter!=rnumbers.end();iter++)
		{

//			cout<<*iter<<endl;

			Ylist[p].push_back(tempY[*iter]);

		}


//		cout<<endl;

	}
	
}



//calculate chi_scores for all Xi and their corresponding Xj's
//the Ylist contains the permutations of the same phenotype
float anova_by_accessing_list_of_r1list(const vector<biSNP>& X,  const biSNP directX[], const qtPhenotype Ylist[],list<TwoLocus>& topk_list)
{
	for (int p=0;p<PERMUTATION;p++)
	{
		if (Ylist[p].size()!=TOTAL_NUMBER_OF_INDIVIDUALS) 
		{
			cout<<"phenotype size wrong!"<<endl;
			return -1;
		}
	}

	float CM = get_CM(Ylist[0]);
	float SS_Total = get_SS_Total(Ylist[0], CM);

	///////////////permutation start/////////////////////////
	clock_t start_time = clock();

	clock_t time_read_in_listofr1list = clock();
	clock_t time_access_listofr1list = clock();
	clock_t time_chi_square_computing = clock();
	clock_t time_update = clock();
	


	__int64 visited=0;////////////////////////////

	float theta=0;

	int i=0, j=0;

//	list<TwoLocus> topk_list[PERMUTATION];


	list<R1list> listofr1list;
	
	list<float> ctable_2[2], ctable_4[4];


	float SSB_XiY;



	vector<biSNP>::const_iterator iter1, iter2;


	list<int> tempcandidatelist;

	list<int>::const_iterator iter3;




	for (iter1=X.begin();iter1!=X.end();++iter1)
	{
        if (i%(MAX_NUM_OF_SNPS/100)==0) 
		{
			cout <<"@@" <<i*100/MAX_NUM_OF_SNPS <<endl; //Send out progress percentages.

			//cout<<theta<<endl;
		}
	    
//		cout<<i<<endl;

		//////////generate the list of r1list on the fly///////////////

		clock_t time1 = clock();

		float r1, r2;

		iter2=iter1;
		iter2++;

		listofr1list.clear();

		int k=i+1;

		for(;iter2!=X.end();++iter2)
		{ 
			get_R1_R2((*iter1), (*iter2), r1, r2);

			update_list_of_r1list(listofr1list, r1, r2, k);

			k++;
		}

		
		time1 = clock()-time1;
		time_read_in_listofr1list = time_read_in_listofr1list + time1;


		for (int p=0;p<PERMUTATION;p++)
		{

			fill_ctable_2(Ylist[p], (*iter1), ctable_2);

			SSB_XiY = get_SS_Between_ctable_2(ctable_2, CM);

			clock_t time2 = clock();

			if (topk_list.size()!=0) 
			{
				theta = (topk_list.back()).F_score;

//				cout<<theta<<endl;
			}

			access_list_of_r1list(ctable_2[0], ctable_2[1], listofr1list, SSB_XiY, SS_Total, theta, tempcandidatelist);

			visited = visited + tempcandidatelist.size();
			
			time2 = clock()-time2;
			time_access_listofr1list = time_access_listofr1list + time2;


				clock_t time3 = clock();
				//clock_t time4;			
			for (iter3=tempcandidatelist.begin();iter3!=tempcandidatelist.end();++iter3)
			{


				j=*iter3;
//				time4=clock();
				//fill_ctable_4(Ylist[p], directX[i].genotype, directX[j].genotype, ctable_4);

				//			time4= clock()-time4;
				TwoLocus tempelem;

				tempelem.phenotype_id = p;///////////////////////////

				tempelem.Xi_id=i;
				tempelem.Xj_id=j;
                tempelem.Xi_genotype.resize(MAX_NUM_OF_INDIVIDUALS);                
				tempelem.Xi_genotype.reset();                
				tempelem.Xi_genotype |= directX[i];
                tempelem.Xj_genotype.resize(MAX_NUM_OF_INDIVIDUALS);
				tempelem.Xj_genotype.reset();
				tempelem.Xj_genotype |= directX[j];
				//tempelem.F_score = get_F_ctable_4(ctable_4, SS_Total, CM);
				tempelem.F_score = get_F(Ylist[p], directX[i], directX[j], SS_Total, CM);

				
				update_topk_list_pid(topk_list, tempelem);
				
//				time_update=time4+ time_update;				
				

	//			output_topklist(topk_list);

		
				//set theta accordingly
	//			if (topk_list.size()==TOPK) 
				{
	//				theta=topk_list.back().chi_score;

				}
	//			else theta=0;
					

			}
			time3 = clock()-time3;			
			time_chi_square_computing = time_chi_square_computing + time3;




		}

		i++;
			
	}


	// Output part.
	cout <<endl;
	cout <<"#=== Step 1: Finding Critical Value in Permutations ===#" <<endl;
	cout <<"#Critical Value(F_alpha):" <<endl;
	cout <<theta <<endl <<endl;
	
//	dataout<<"pruncount: "<<pruncount<<endl;
	cout<<"#------------ Step 1 Runtime Statistics ----------#" <<endl;	

	//cout<<"#Listofr1list generating time: "<<((double)(time_read_in_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	//cout<<"#Listofr1list access time: : "<<((double)(time_access_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	//cout<<"#Chi-square computing time:: "<<((double)(time_chi_square_computing-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	//cout<<"#Update time:: "<<((double)(time_update-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	cout<<"#Run time: "<<((double)clock() - start_time)/ CLOCKS_PER_SEC<<"  seconds"<<endl;


	char buf[20];
	sprintf(buf,"%lld", visited);
	cout<<"#Visited pairs: "<<buf<<endl;
    __int64 total_pairs=NUM_OF_PERMUTATIONS*MAX_NUM_OF_SNPS*(MAX_NUM_OF_SNPS-1)/2;
    cout <<"Pruning raio:" <<(total_pairs-visited)*1.0/total_pairs <<endl;    
	cout<<"#------- End of Step 1 Runtime Statistics --------#" <<endl <<endl <<endl;	
	//cout <<theta <<endl;	
	return theta;	
}


float anova_no_permutation(const vector<biSNP>& X,  const biSNP directX[], const qtPhenotype Y, float theta, const vector<long>& X_pos)
{
	float CM = get_CM(Y);
	float SS_Total = get_SS_Total(Y, CM);

	///////////////permutation start/////////////////////////
	clock_t start_time = clock();

	clock_t time_read_in_listofr1list = clock();
	clock_t time_access_listofr1list = clock();
	clock_t time_chi_square_computing = clock();
	clock_t time_update = clock();
	


	__int64 visited=0;////////////////////////////

	//float theta=0;

	int i=0, j=0;

//	list<TwoLocus> sign_list[PERMUTATION];
	list<TwoLocus> sign_list;

	list<R1list> listofr1list;
	
	list<float> ctable_2[2], ctable_4[4];


	float SSB_XiY;


	//theta=15;
	
	vector<biSNP>::const_iterator iter1, iter2;


	list<int> tempcandidatelist;

	list<int>::const_iterator iter3;
	
	for (iter1=X.begin();iter1!=X.end();++iter1)
	{
        /*
		if (i%(MAX_NUM_OF_SNPS/100)==0) 
		{
			cout <<"@@" <<i*100/MAX_NUM_OF_SNPS <<endl; //Send out progress percentages.

			//cout<<theta<<endl;
		}
        */
//		cout<<i<<endl;

		//////////generate the list of r1list on the fly///////////////

		clock_t time1 = clock();

		float r1, r2;

		iter2=iter1;
		iter2++;

		listofr1list.clear();

		int k=i+1;

		for(;iter2!=X.end();++iter2)
		{ 
			get_R1_R2((*iter1), (*iter2), r1, r2);

			update_list_of_r1list(listofr1list, r1, r2, k);

			k++;
		}

		
		time1 = clock()-time1;
		time_read_in_listofr1list = time_read_in_listofr1list + time1;


//		for (int p=0;p<PERMUTATION;p++)
//		{
			fill_ctable_2(Y, (*iter1), ctable_2);

			SSB_XiY = get_SS_Between_ctable_2(ctable_2, CM);

			clock_t time2 = clock();
/*
			if (sign_list.size()!=0) 
			{
				theta = (sign_list.back()).F_score;

//				cout<<theta<<endl;
			}
*/
			access_list_of_r1list(ctable_2[0], ctable_2[1], listofr1list, SSB_XiY, SS_Total, theta, tempcandidatelist);

			visited = visited + tempcandidatelist.size();
			
			time2 = clock()-time2;
			time_access_listofr1list = time_access_listofr1list + time2;


				clock_t time3 = clock();
				//clock_t time4;			
			for (iter3=tempcandidatelist.begin();iter3!=tempcandidatelist.end();++iter3)
			{


				j=*iter3;
//				time4=clock();
				//fill_ctable_4(Ylist[p], directX[i].genotype, directX[j].genotype, ctable_4);

				//			time4= clock()-time4;
				TwoLocus tempelem;

				tempelem.phenotype_id = 0;///////////////////////////

				tempelem.Xi_id=i;
				tempelem.Xj_id=j;
                tempelem.Xi_genotype.resize(MAX_NUM_OF_INDIVIDUALS);
				tempelem.Xi_genotype.reset();
				tempelem.Xi_genotype |= directX[i];
                tempelem.Xj_genotype.resize(MAX_NUM_OF_INDIVIDUALS);
				tempelem.Xj_genotype.reset();
				tempelem.Xj_genotype |= directX[j];
				//tempelem.F_score = get_F_ctable_4(ctable_4, SS_Total, CM);
				tempelem.F_score = get_F(Y, directX[i], directX[j], SS_Total, CM);

				if (tempelem.F_score>=theta){
				    sign_list.push_back(tempelem);				    
				}
				
				//update_sign_list_pid(sign_list, tempelem);
				
//				time_update=time4+ time_update;				
				

	//			output_topklist(sign_list);

		
				//set theta accordingly
	//			if (sign_list.size()==TOPK) 
				{
	//				theta=sign_list.back().chi_score;

				}
	//			else theta=0;
					

			}
			time3 = clock()-time3;			
			time_chi_square_computing = time_chi_square_computing + time3;




			//	}

		i++;
			
	}


/*
	for (int p=0;p<PERMUTATION;p++)
	{

		dataout<<"phenotype: ";

		dataoutput_floatlist(Ylist[p]);
		
		dataout<<endl;
	}
*/
	sign_list.sort();
	cout<<"#======= Step 2: Finding Significant SNP pairs ========#" <<endl;
	cout<<"#Num of Significant SNP pairs" <<endl;
	cout<<sign_list.size() <<endl;	
	cout<<"#-------------- Significant SNP pairs ------------#" <<endl;
	dataoutput_significant(sign_list,Y,X_pos);
	cout<<"#---------- End of Significant SNP pairs ---------#" <<endl <<endl;

//	dataout<<"pruncount: "<<pruncount<<endl;
	cout<<"#------------ Step 2 Runtime Statistics ----------#" <<endl;
	//cout<<"#Listofr1list generating time: "<<((double)(time_read_in_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	//cout<<"#Listofr1list access time: : "<<((double)(time_access_listofr1list-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	//cout<<"#Chi-square computing time:: "<<((double)(time_chi_square_computing-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	//cout<<"#Update time:: "<<((double)(time_update-start_time))/ CLOCKS_PER_SEC<<"  seconds"<<endl;
	cout<<"#Run time: "<<((double)clock() - start_time)/ CLOCKS_PER_SEC<<"  seconds"<<endl;


	//char buf[20];
	//sprintf(buf,"%lld", visited);
	//cout<<"#Visited pairs: "<<buf<<endl;
	cout<<"#------- End of Step 2 Runtime Statistics --------#" <<endl <<endl <<endl;	

	return theta;	
}
