#include <iostream>
#include <fstream>
#include <list>
#include <stack>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <time.h>
#include <algorithm>
#include <sstream>

#include <cmath>

#include "1_global.h"
#include "2_inputoutputfuncs.h"
#include "3_contingencytable.h"
#include "4_standard_anova.h"
#include "5_listfuncs.h"
#include "7_r1r2list.h"

using namespace std;

#include "../common/global.hpp"

#define verbose 1

int MAX_NUM_OF_INDIVIDUALS;
int MAX_NUM_OF_SNPS;
int NUM_OF_PERMUTATIONS;


void test()

{

	clock_t start_time = clock();


 	//list<float> Y;
    qtPhenotype Y;    
	//list<SNP> X;
    vector<biSNP> X;
    
	vector<long> X_pos;
	
	getin_data(Y, X, X_pos);



//	output_floatlist(Y);

//	output_SNPlist(directX);

//	getchar();

	qtPhenotype Ylist[PERMUTATION];
	list<TwoLocus> topk_list;



	permute_phenotype(Y, Ylist);



    
	//output_Ylist_permutation(Ylist);
	
/*	list<float>::const_iterator iter;

	for (int p=0;p<PERMUTATION;p++)
	{
		for (iter=Y.begin();iter!=Y.end();iter++)
		{
			Ylist[p].push_back(*iter);

		}
		
	}
*/
    
	dataoutput_args();
	
	float theta=anova_by_accessing_list_of_r1list(X, directX, Ylist,topk_list);
	
	anova_no_permutation(X,directX,Y,theta,X_pos);	
	//dataoutput_permutations(Ylist);
	//dataoutput_topklist(topk_list,Ylist,X_pos);

    
//	cout<<get_sum_of_last_m_elements(Y, 2.0)<<endl;;

//	output_floatlist(Y);

/*	float R1, R2;

	get_R1_R2(directX[0].genotype, directX[1].genotype, R1, R2);

	cout<<R1<<" "<<R2<<endl;
*/

/*
	float CM=0;
	
	CM = get_CM(Y);

	float SS_Total=0;

	SS_Total = get_SS_Total(Y, CM);

	cout<<"SS_Total: "<<SS_Total<<endl;
	
	list<float> ctable_2[2];

	
	fill_ctable_2(Y, directX[0].genotype, ctable_2);
	
	output_ctable_2(ctable_2);

	cout<<"SS_B_ctable_2: "<<get_SS_Between_ctable_2(ctable_2, CM)<<endl;

//	fill_ctable_2(Y, directX[0].genotype, ctable_2);
	
//	output_ctable_2(ctable_2);

//	cout<<get_SS_Between_ctable_2(ctable_2, CM)<<endl;

//	cout<<get_F_ctable_2(ctable_2, SS_Total, CM)<<endl;


	cout<<get_one_R(ctable_2[0], 6)<<endl;
	cout<<get_one_R(ctable_2[0], 5)<<endl;




//	output_SNPlist(X);
//	output_SNPlist(directX);

	list<float> ctable_4[4];


	
	fill_ctable_4(Y, directX[0].genotype, directX[1].genotype, ctable_4);
	
	output_ctable_4(ctable_4);

	cout<<"bound of delta A: "<<get_upperbound(ctable_2[0], ctable_4[1].size())<<endl;
	cout<<"bound of delta B: "<<get_upperbound(ctable_2[1], ctable_4[3].size())<<endl;

	
	cout<<"SS_B_ctable_4: "<<get_SS_Between_ctable_4(ctable_4, CM)<<endl;

//	cout<<get_F_ctable_4(ctable_4, SS_Total, CM)<<endl;

*/
	cout<<"@@100" <<endl;	
	cout<<"Running time: "<<((double)clock() - start_time)/ CLOCKS_PER_SEC<<"  seconds"<<endl;
}


//**********MAIN***********
//*************************

int main(int argc, char * argv[])
{
    if (argc<7) {
        cerr <<"Error: Not enough parameters!" <<endl;
        cerr <<"Usage: " <<argv[0] <<" geno_fn pheno_fn #individuals #SNPs #permutations fwer_threshold pos_fn" <<endl;        
        return 1;
    }
    
    string INPUTFILE_1(argv[1]);
    geno_infile.open(INPUTFILE_1.c_str());
    if (geno_infile.fail()){
        cerr <<"Error: Cannot open "+INPUTFILE_1+" to read!" <<endl;
        exit(1);                
    };

    string INPUTFILE_2(argv[2]);
    pheno_infile.open(INPUTFILE_2.c_str());
    if (pheno_infile.fail()){
        cerr <<"Error: Cannot open "+INPUTFILE_2+" to read!" <<endl;
        return 1;        
    };

    MAX_NUM_OF_INDIVIDUALS=atoi(argv[3]);
    MAX_NUM_OF_SNPS=atoi(argv[4]);
    NUM_OF_PERMUTATIONS=atoi(argv[5]);
    float fwer_threshold=atof(argv[6]);
    
    TOPK=int(floor(fwer_threshold*NUM_OF_PERMUTATIONS));    
    
    TOTAL_NUMBER_OF_INDIVIDUALS=MAX_NUM_OF_INDIVIDUALS;
    NUMBER_OF_SNPs=MAX_NUM_OF_SNPS;
    PERMUTATION = NUM_OF_PERMUTATIONS;

	if (argc>7)
		INPUTFILE_3 = argv[7];
	else
		INPUTFILE_3 = "";	
	
	test();

	//getchar();

	return 0;
}


